| OpenCV 5.0.0alpha Open Source Computer Vision

Loading...
Searching...
No Matches
Public Member Functions | List of all members
cv::bgsegm::BackgroundSubtractorCNT Class Referenceabstract
Improved Background-Foreground Segmentation Methods

Background subtraction based on counting. More...

`#include <opencv2/bgsegm.hpp>`

Collaboration diagram for cv::bgsegm::BackgroundSubtractorCNT:

## Public Member Functions
virtual void | apply (InputArray image, OutputArray fgmask, double learningRate=-1) CV_OVERRIDE=0
| Computes a foreground mask.
virtual void | getBackgroundImage (OutputArray backgroundImage) const CV_OVERRIDE=0
| Computes a background image.
virtual bool | getIsParallel () const =0
| Returns if we're parallelizing the algorithm.
virtual int | getMaxPixelStability () const =0
| Returns maximum allowed credit for a pixel in history.
virtual int | getMinPixelStability () const =0
| Returns number of frames with same pixel color to consider stable.
virtual bool | getUseHistory () const =0
| Returns if we're giving a pixel credit for being stable for a long time.
virtual void | setIsParallel (bool value)=0
| Sets if we're parallelizing the algorithm.
virtual void | setMaxPixelStability (int value)=0
| Sets the maximum allowed credit for a pixel in history.
virtual void | setMinPixelStability (int value)=0
| Sets the number of frames with same pixel color to consider stable.
virtual void | setUseHistory (bool value)=0
| Sets if we're giving a pixel credit for being stable for a long time.
Public Member Functions inherited from cv::BackgroundSubtractor
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state.
virtual bool | empty () const
| Returns true if the Algorithm is empty (e.g. in the very beginning or after unsuccessful read.
virtual String | getDefaultName () const
virtual void | read (const FileNode &fn)
| Reads algorithm parameters from a file storage.
virtual void | save (const String &filename) const
virtual void | write (FileStorage &fs) const
| Stores algorithm parameters in a file storage.
void | write (FileStorage &fs, const String &name) const

## Additional Inherited Members
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file.
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String.
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node.
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

Background subtraction based on counting.

About as fast as MOG2 on a high end system. More than twice faster than MOG2 on cheap hardware (benchmarked on Raspberry Pi3).

Algorithm by Sagi Zeevi ( https://github.com/sagi-z/BackgroundSubtractorCNT )

## Member Function Documentation

## ◆ apply()

virtual void cv::bgsegm::BackgroundSubtractorCNT::apply | ( | InputArray | image,
|  | OutputArray | fgmask,
|  | double | learningRate = -1 )
| pure virtual

Python:
| cv.bgsegm.BackgroundSubtractorCNT.apply( | image[, fgmask[, learningRate]] | ) -> | fgmask

Computes a foreground mask.

Parameters

  image | Next video frame.
  fgmask | The output foreground mask as an 8-bit binary image.
  learningRate | The value between 0 and 1 that indicates how fast the background model is learnt. Negative parameter value makes the algorithm to use some automatically chosen learning rate. 0 means that the background model is not updated at all, 1 means that the background model is completely reinitialized from the last frame.

Implements cv::BackgroundSubtractor.

## ◆ getBackgroundImage()

virtual void cv::bgsegm::BackgroundSubtractorCNT::getBackgroundImage | ( | OutputArray | backgroundImage | ) | const
| pure virtual

Python:
| cv.bgsegm.BackgroundSubtractorCNT.getBackgroundImage( | [, backgroundImage] | ) -> | backgroundImage

Computes a background image.

Parameters

  backgroundImage | The output background image.

Note
  Sometimes the background image can be very blurry, as it contain the average background statistics.

Implements cv::BackgroundSubtractor.

## ◆ getIsParallel()

virtual bool cv::bgsegm::BackgroundSubtractorCNT::getIsParallel | ( |  | ) | const
| pure virtual

Python:
| cv.bgsegm.BackgroundSubtractorCNT.getIsParallel( |  | ) -> | retval

Returns if we're parallelizing the algorithm.

## ◆ getMaxPixelStability()

virtual int cv::bgsegm::BackgroundSubtractorCNT::getMaxPixelStability | ( |  | ) | const
| pure virtual

Python:
| cv.bgsegm.BackgroundSubtractorCNT.getMaxPixelStability( |  | ) -> | retval

Returns maximum allowed credit for a pixel in history.

## ◆ getMinPixelStability()

virtual int cv::bgsegm::BackgroundSubtractorCNT::getMinPixelStability | ( |  | ) | const
| pure virtual

Python:
| cv.bgsegm.BackgroundSubtractorCNT.getMinPixelStability( |  | ) -> | retval

Returns number of frames with same pixel color to consider stable.

## ◆ getUseHistory()

virtual bool cv::bgsegm::BackgroundSubtractorCNT::getUseHistory | ( |  | ) | const
| pure virtual

Python:
| cv.bgsegm.BackgroundSubtractorCNT.getUseHistory( |  | ) -> | retval

Returns if we're giving a pixel credit for being stable for a long time.

## ◆ setIsParallel()

virtual void cv::bgsegm::BackgroundSubtractorCNT::setIsParallel | ( | bool | value | ) |
| pure virtual

Python:
| cv.bgsegm.BackgroundSubtractorCNT.setIsParallel( | value | ) -> | None

Sets if we're parallelizing the algorithm.

## ◆ setMaxPixelStability()

virtual void cv::bgsegm::BackgroundSubtractorCNT::setMaxPixelStability | ( | int | value | ) |
| pure virtual

Python:
| cv.bgsegm.BackgroundSubtractorCNT.setMaxPixelStability( | value | ) -> | None

Sets the maximum allowed credit for a pixel in history.

## ◆ setMinPixelStability()

virtual void cv::bgsegm::BackgroundSubtractorCNT::setMinPixelStability | ( | int | value | ) |
| pure virtual

Python:
| cv.bgsegm.BackgroundSubtractorCNT.setMinPixelStability( | value | ) -> | None

Sets the number of frames with same pixel color to consider stable.

## ◆ setUseHistory()

virtual void cv::bgsegm::BackgroundSubtractorCNT::setUseHistory | ( | bool | value | ) |
| pure virtual

Python:
| cv.bgsegm.BackgroundSubtractorCNT.setUseHistory( | value | ) -> | None

Sets if we're giving a pixel credit for being stable for a long time.

The documentation for this class was generated from the following file:

- opencv2/bgsegm.hpp